<!DOCTYPE html>
<!--
To change this license header, choose License Headers in Project Properties.
To change this template file, choose Tools | Templates
and open the template in the editor.
-->
<html xmlns:th="https://www.thymeleaf.org">
    <head>
        <!-- Required meta tags -->
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <!-- Bootstrap CSS -->
        <!--<link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-1BmE4kWBq78iYhFldvKuhfTAU6auU8tT94WrHftjDbrCEXSU1oBoqyl2QvZ6jIW3" crossorigin="anonymous">-->
        <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">
        <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-ka7Sk0Gln4gmtz2MlQnikT1wXgYsOg+OMhuP+IlRH9sENBO0LRn5q+8nbTov4+1p" crossorigin="anonymous"></script>
        <title>Hello, Codeworld!</title>
        <script src="https://cdn.jsdelivr.net/npm/vue@2.6.14"></script>
        <script src="https://code.jquery.com/jquery-3.6.0.js" integrity="sha256-H+K7U5CnXl1h5ywQfKtSj8PCmoN9aaq30gDh27Xc0jk=" crossorigin="anonymous"></script>
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.10.4/font/bootstrap-icons.css">
        <script src="https://cdn.jsdelivr.net/npm/busy-load@0.1.2/dist/app.min.js"></script>
        <link href="https://cdn.jsdelivr.net/npm/busy-load@0.1.2/dist/app.min.css" rel="stylesheet">
    </head>
    <body>
          
            <div class='container' id="app">
                <table class="table">
                    <thead>
                        <tr>
                            <th>Package</th>
                            <th>Name</th>
                            <th>Version</th>
                            <th>Description</th>
                            <th></th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr v-for="appEntry in appEntries">
                            <td>{{appEntry.packageName}}</td>
                            <td>{{appEntry.displayName}}</td>
                            <td>{{appEntry.version}}</td>
                            <td>{{appEntry.description}}</td>
                            <td>
                                <button v-if="!appEntry.upgradable" class="btn btn-primary" v-on:click="install(appEntry);">Install</button>
                                <button v-if="appEntry.upgradable" class="btn btn-warning" v-on:click="upgrade(appEntry);">Upgrade</button>
                            </td>
                        </tr>
                    </tbody>
                </table>
            </div>
            <script th:inline="javascript">
                
                
            </script>
            <script>
                $.busyLoadSetup({animation: "slide", background: "rgba(127,63,191,0.54)"});
                let app=new Vue({
                    el: "#app",
                    data:{
                        appEntries: []
                    },
                    methods:{

                        install: function(appEntry){
                            $.busyLoadFull("show", {text: "LOADING ...", textColor: "white", color: "#DCB5FF", textPosition: "bottom"});

                            $.ajax("/install", {
                                type: "POST",
                                contentType: "application/json",
                                data: JSON.stringify(appEntry),
                                success: function(d){
                                    $.busyLoadFull("hide");
                                    window.location.reload();
                                },
                                error: function(){
                                    $.busyLoadFull("hide");
                                }
                            });
                        },
                        upgrade: function(appEntry){
                            $.busyLoadFull("show", {text: "LOADING ...", textColor: "white", color: "#DCB5FF", textPosition: "bottom"});

                            $.ajax("/upgrade", {
                                type: "PUT",
                                contentType: "application/json",
                                data: JSON.stringify(appEntry),
                                success: function(d){
                                    $.busyLoadFull("hide");
                                    window.location.reload();
                                },
                                error: function(){
                                    $.busyLoadFull("hide");
                                }
                            });
                        },
                    }
                });
                $(document).ready(()=>{
                    $.ajax('/apps/installable', {
                        success: function(d){
                            app.appEntries=d;
                        }
                    });
                });
            </script>
    </body>
</html>
